//  ____       _   _            __  __ ______ _____  _____  
// |  _ \     | | | |          |  \/  |  ____|  __ \|  __ \ 
// | |_) | ___| |_| |_ ___ _ __| \  / | |__  | |__) | |__) |
// |  _ < / _ \ __| __/ _ \ '__| |\/| |  __| |  _  /|  ___/ 
// | |_) |  __/ |_| ||  __/ |  | |  | | |____| | \ \| |     
// |____/ \___|\__|\__\___|_|  |_|  |_|______|_|  \_\_|     
//                                                   
//                   by ZombieDude

//Some credits?

//zombiedude - i made like everything
//Golem - made me a sweet grave, tested a ton of stuff, overall awesome dude
//Czar - helped test the final version, cool dude
//ATrueWarrior - tester
//madnesskiller6 - tester
//SilverSummer - tester
//Greek2Me (Slayer) and Tezuni (Moderator) for making some of the functions I use (rgbtohex and subString respectively)

//Prefs first i guess
if(isFile("Add-Ons/System_ReturnToBlockland/server.cs") || isFile("Add-Ons/System_BlocklandGlass/server.cs")){
	if($Merp::LoadedOnce){
		echo("[BetterMERP V1]: Prefs already registered, returning.");
		return;
	}
	echo("[BetterMERP V1]: RTB/Glass found! Registering preferences.");
	RTB_registerPref("Name Character Limit", "BetterMERP", "Pref::Merp::NameCharLimit", "int 1 500", "Server_BetterMERP", 75, 0, 0);
	RTB_registerPref("Default Random Number", "BetterMERP", "Pref::Merp::DefaultRNum", "int 1 1000", "Server_BetterMERP", 20, 0, 0);
	RTB_registerPref("Max Random Number", "BetterMERP", "Pref::Merp::MaxRNum", "int 1 1000000", "Server_BetterMERP", 1000, 0, 0);
	RTB_registerPref("Empire Chat Font Size", "BetterMERP", "Pref::Merp::EmpTextFontSize", "int 1 50", "Server_BetterMERP", 26, 0, 0);
	$Merp::LoadedOnce = true;
}

else{
	if($Merp::LoadedOnce){
		echo("[BetterMERP V1]: Executing preferences.");
		exec("Add-Ons/Server_BetterMERP/mprefs.cs");
		return;
	}
	echo("[BetterMERP V1]: RTB/Glass not present. Creating default prefs..");
	$Pref::Merp::NameCharLimit = 75;
	$Pref::Merp::DefaultRNum = 20;
	$Pref::Merp::MaxRNum = 1000;
	$Pref::Merp::EmpTextFontSize = 26;
	$Pref::Merp::EmpPrefixStyle = "***";
	export("$Pref::Merp::*","Add-Ons/Server_BetterMERP/mprefs.cs");
	$Merp::LoadedOnce = true;
}
$Pref::Merp::LogsToggled = true;
exec("Add-Ons/Server_BetterMERP/mprefs.cs");
//////////////////////
//FUNCTIONS SECTION//
////////////////////
//Taken from Script_Moderator, sorry!
function subString(%string, %substring){
	return strStr(strLwr(%string), strLwr(%substring)) >= 0 ? 1 : 0;
}

//Taken from.. me?
function findPlayerTargetMERP(%thisName,%name){
	if(findclientbyname(%thisName)){
		%this = findclientbyname(%thisName);
	}
	%numNames = 0;
	for(%i=0;%i<ClientGroup.getCount();%i++){
		%cl = ClientGroup.getObject(%i);
		if(subString(%cl.Name,%name)){
			//If you find a client by the name, set a var
			%targ = findclientbyname(%cl.Name);
			%numNames++;
		}
		if(%numNames > 1){
			//If more than one is found with the same substring
			messageClient(%this,'',"\c6There is more than one person with \'\c3"@%name@"\c6\' in their name, try again (be more specific!)");
			return 0;
		}
	}
	if(%numNames == 0){
		//If nothings found
		messageClient(%this,'',"\c6There are no players with \'\c3"@%name@"\c6\' in their name, try again.");
		return 0;
	}
	return %targ;
}

//logger, its like frogger
function merpLog(%fpath,%logstring){
	if(%fpath !$= "" && %logstring !$= ""){
		%file = new fileObject();

		%file.openForAppend(%fpath);
		%file.WriteLine(%logstring);

		%file.close();
		%file.delete();
	}
	else{
		return;
	}
}
//I use this a couple tiems
function mAtWarWith(%c,%targ){
	if(%c.warCount != 0){
		%empnum = 0;
		for(%i=0;%i<%c.warCount;%i++){
			if(%c.atWar[%i] $= %targ.empireName){
				%empnum = %empnum + 1;
				break;
			}
		}
		if(%empnum == 1){
			return true;
		}
		else return false;
	}
	else return false;
}
//And this once
function mAllyWith(%c,%targ){
	if(%c.allyCount != 0){
		%empnum = 0;
		for(%i=0;%i<%c.allyCount;%i++){
			if(%c.allynum[%i] $= %targ.empireName){
				%empnum = %empnum + 1;
			}
		}
		if(%empnum == 1){
			return true;
		}
		else return false;
	}
	else return false;
}

function reqDelete(%c){
	if(%c.hasARequest == true){
		%c.hasARequest = false;
		%c.Mrequestname = "";
		%c.typeReq = "";
	}
	else return;
}
///////////////////////////////////////////////////
//No more normal functions, on to server commands//
///////////////////////////////////////////////////

function serverCmdmHelp(%c,%command){
	%com = strlwr(%command);
	if(%com $= "merp"){
		messageClient(%c,'',"<font:palatino linotype:23>\c3MERP:");
		messageclient(%c,'',"\c3MERP\c6, or \c3Mini Empires Roleplay\c6, is a gamemode thats been around for a long time in Blockland.");
		messageclient(%c,'',"\c6You control an empire and build miniature settlements, towns, buildings, and units to fight other players with.");
		messageclient(%c,'',"\c6This Add-On (hopefully) improves that concept.");
		return;
	}
	else if(%com $= "empirecom"){
		messageClient(%c,'',"\c3<font:palatino linotype:23>Empire Creation Commands:");
		messageClient(%c,'',"\c3/empirename\c6 creates your empire for you, and tells everyone what its called! It can take up to 7 words (you shouldn't need more, anyway).");
		messageClient(%c,'',"\c3/empirecolor\c6 takes one input, the hexadecimal color or colorset number. For example, /empirecolor FA60B6. (Use /rgbtohex for rgb numbers)");
		messageClient(%c,'',"\c6Hexadecimal colors consist of six numbers/letters, like <color:ABC123>ABC123\c6going from 0123456789ABCDEF.");
		messageClient(%c,'',"\c6The first two are <color:FF0000>red\c6, middle two are <color:00FF00>green\c6, and last two are <color:0000FF>blue\c6. There are lots of websites that list these numbers.");
		return;
	}
	else if(%com $= "misc"){
		messageClient(%c,'',"\c3<font:palatino linotype:23>Miscellaneous Commands:");
		messageClient(%c,'',"\c3/rgbtohex\c6 takes 3 inputs, the red value, blue value, and green value. This command converts the RGB in to a usable (for \c3/empirecolor\c6) hexadecimal string!");
		messageClient(%c,'',"\c6Hard pressed for an empire name? \c3/empirenamegen\c6 randomly generates one for you! It takes no inputs, so you can just type it in until you find one you want.");
		messageClient(%c,'',"\c3/rolldice\c6, surprisingly, rolls a die. It can take one input, the max number you want to roll, but just typing /rolldice will select a default number (For this server, \c3"@$Pref::Merp::DefaultRNum@"\c6.)");
		messageClient(%c,'',"\c3/mwhisper\c6 lets you tell someone about your evil mastermind plans. Just type /mwhisper [playername] [message] and it'll get sent.");
		messageClient(%c,'',"\c6Forgetful? \c3/whatsmycolor\c6 tells you the hex code you used for your empire's color.");
		return;
	}
	else if(%com $= "warandpeace"){
		messageClient(%c,'',"\c3<font:palatino linotype:23>War Commands:");
		messageClient(%c,'',"\c6This one's real good. \c3/declarewar\c6 takes one input, the target's name you're declaring war against, NOT the empire's name.");
		messageClient(%c,'',"\c3/declarewar\c6 announces to everyone that you and your target are officially at war. Type \c3/warstatus\c6 to find out all of the wars happening now.");
		messageClient(%c,'',"\c6Are you tired of the meaningless war between you and [playername]? Type \c3/makepeace [playername]\c6 and if the player accepts, you will be at peace!");
		messageClient(%c,'',"\c6It will announce to everyone that you two aren't fighting any more, and might be best pals.");
		return;
	}
	else if(%com $= "allies"){
		messageClient(%c,'',"\c3<font:palatino linotype:23>Alliance Commands:");
		messageClient(%c,'',"\c6You can make alliances (and break them too!) You can type \c3/makealliance [playername]\c6, and they'll be prompted to ally with you.");
		messageClient(%c,'',"\c6Tired of that Blockhead you allied with yelling at you? Type \c3/breakalliance [playername]\c6 to get rid of that whole ordeal.");
		messageClient(%c,'',"\c6New player? Don't know the big alliances? Type \c3/allystatus\c6 to find out for yourself.");
		return;
	}
	messageClient(%c,'',"");
	messageClient(%c,'',"\c3<font:palatino linotype:23>You can use the following commands with /mHelp below:");
	messageClient(%c,'',"\c6/mHelp merp - information on the mini empires gamemode");
	messageClient(%c,'',"\c6/mHelp empirecom - information on \c3making an empire");
	messageClient(%c,'',"\c6/mHelp warandpeace - info on \c3declaring war\c6, \c3making peace\c6");
	messageClient(%c,'',"\c6/mHelp allies - info on \c3making\c6 and \c3breaking \c6alliances, and finding out what alliances there are");
	messageClient(%c,'',"\c6/mHelp misc - info on miscellaneous commands, like \c3/rolldice\c6, \c3/rgbtohex\c6, \c3/mwhisper\c6 and my favorite \c3/empirenamegen");
	return;
}

//..and /mHelpS, for all the admins out there

function serverCmdmHelpS(%c){
	messageClient(%c,'',"\c3<font:palatino linotype:23>Admin Only Commands:");
	messageClient(%c,'',"\c3/godWhisper [target] [message]:\c6 Sends an anonymous message to a target. Good for telling players not to do things and enforcing rules.");
	messageClient(%c,'',"\c3/mAnnounce [message]:\c6 Announces something to every player in the game. Be creative: you can cause random events, or narrate a war. You can only use 13 words, though.");
	messageClient(%c,'',"\c6You can also type \c3/clearempdata\c6 to clear \c3*ALL*\c6 empire names and colors. (host only!)");
	messageClient(%c,'',"\c6Logging: The server takes logs of \c3every single empire name \c6and \c3every single chat message typed by an empire. Type \c3/togglelogs (host only!) to disable it.");
	messageClient(%c,'',"\c6You can find all \c3logs\c6 in the \c3\"logs\"\c6 folder in the Server_BetterMERP add-on. \c3empnames.txt\c6 is all empire names and \c3empchat.txt\c6 is all empire chat.");
	messageClient(%c,'',"\c6This addon also includes a variety of preferences, of which you can change in the Server_BetterMERP folder under mprefs.cs, or with \c3Blockland Glass\c6/\c3RTB Preferences.");
}

//Toggle logs
//Tloggle?
//Loggle?
//Loggle.
function serverCmdtogglelogs(%c){
	if(%c.bl_id == getNumKeyID()){
		if($Pref::Merp::LogsToggled){
			$Pref::Merp::LogsToggled = false;
			messageClient(%c,'',"\c6You have turned logs \c3off\c6.");
		}
		else{
			$Pref::Merp::LogsToggled = true;
			messageClient(%c,'',"\c6You have turned logs \c3on\c6.");
		}
	}
	else{
		messageClient(%c,'',"\c6You are not the host.");
	}
}
//Clear logs
//Clogs
//This sdoesnt work for some reason so i commented it out if someone requests it ill try and make it work
//function serverCmdclearlogs(%c){
	//if(%c.bl_id == getNumKeyID()){
	//	export("Add-Ons/Server_BetterMERP/logs/empnames.txt","1");
	//	export("Add-Ons/Server_BetterMERP/logs/empchat.txt","1");
	//	messageClient(%c,'',"\c6Logs cleared.");
//	}
//}

//The functions people care about! Except rgbtohex, nobody uses rgbtohex

//Speak of the devil
function serverCmdRGBToHex(%c,%r,%g,%b)
{
	if(%r < 256 && %r >= 0 && %g < 256 && %g >= 0 && %b < 256 && %b >= 0){
		//use % to find remainder
		if(%r <= 1)
			%r = %r * 255;
		if(%g <= 1)
			%g = %g * 255;
		if(%b <= 1)
			%b = %b * 255;
		%a = "0123456789ABCDEF";

		%r1 = getSubStr(%a,(%r-(%r % 16))/16,1) @ getSubStr(%a,(%r % 16),1);
		%g1 = getSubStr(%a,(%g-(%g % 16))/16,1) @ getSubStr(%a,(%g % 16),1);
		%b1 = getSubStr(%a,(%b-(%b % 16))/16,1) @ getSubStr(%a,(%b % 16),1);

		%col = %r1 @ %b1 @ %g1;
		%str = "<color:" @ %col @ ">";
	
		messageClient(%c,'',%str @ %r SPC %g SPC %b SPC "\c6is" SPC %str @ %col SPC "\c6in hex format.");
	}
	else{
		messageClient(%c,'',"You must use values under 256 and above 0 because rgb");
	}
}
//And this too. I doubt anyone will use this
function servercmdwhatsmycolor(%c){
	if(%c.empireColor !$= "" && %c.incasecolor !$= ""){
		messageClient(%c,'',"\c6Your empire color is: "@%c.incasecolor@"\c6 (which looks like "@%c.empireColor@"this\c6).");
	}
	else{
		messageClient(%c,'',"\c6You don't have an empire color.");
	}
}

function serverCmdEmpireColor(%c,%col){
	//6 letters long is to check if its hexadecimal
	%gotColor = false;
	if(strLen(%col) == 6){
		%hexa = "0123456789ABCDEF";
		%hnum = 0;
		for(%i=0;%i<6;%i++){
			%colh = getSubStr(%col,%i,1);
			if(subString(%hexa,%colh)){
				%hnum++;
			}
		}
		if(%hnum != 6){
			messageClient(%c,'',"\c6That's not a valid hexadecimal code!");
			return;
		}
		%colStr = "<color:" @ %col @ ">";

		%c.clanPrefix = "\c6["@ %colStr @ $Pref::Merp::EmpPrefixStyle @"\c6]";
		%c.empireColor = %colStr;
		%c.incasecolor = %col;

		messageClient(%c,'',"\c6Your empire color is now" @ %colStr SPC %col);
		if(%c.empireName !$= ""){
			%c.fullEmpName = %c.empireColor @ %c.empireName;
		}
		%gotColor = true;
	}
	//Colorset values
	if(%col <= 100 && %gotColor == false){
		//ColorIdTable is the colorset btw
		%colFromSet = getColorIDTable(%col-1);
		if(%color !$= "1.000000 0.000000 1.000000 0.000000"){
			%colFromSetConv = rgbToHex(%colFromSet);
			%colStr = "<color:" @ %colFromSetConv @ ">";

			%c.clanPrefix = "\c6["@ %colStr @ $Pref::Merp::EmpPrefixStyle @"\c6]";
			%c.empireColor = %colStr;

			messageClient(%c,'',"\c6Your empire color is now" @ %colStr SPC %colFromSetConv);
			%gotColor = true;
		}
	}
	if(%col $= ""){
		%c.empireColor = "";
		%c.clanPrefix = "";
		messageClient(%c,'',"\c6If you were clearing your color, ignore this. Otherwise, use a number under 100 or a hex code for your empire color. /rgbtohex exists if you need to convert colors from RGB to hex.");
		return;
	}
	if(!%gotColor){
		messageClient(%c,'',"\c6Sorry, couldn't get that. Please use a hexadecimal code or number under 100 (colorset) for this command.");
	}
}

function serverCmdEmpireName(%c,%n,%n2,%n3,%n4,%n5,%n6,%n7,%n8,%n9){
	if(%c.warCount != 0){
		messageClient(%c,'',"\c6You can't change your empire name while you're at war!");
		return;
	}
	if(%c.allyCount != 0){
		messageClient(%c,'',"\c6You can't change your empire name in an alliance: that would be really confusing.");
		return;
	}
	//Trim makes it so that there arent trailing or following spaces, like if they only used 2 words
	%msg = trim(%n SPC %n2 SPC %n3 SPC %n4 SPC %n5 SPC %n6 SPC %n7 SPC %n8 SPC %n9);
	if(strlen(%msg) <=5 ){
		messageClient(%c,'',"\c6Your empire name must be over \c35\c6 letters long.");
		return;
	}
	//Makes sure the name is less than the char limit
	if(strLen(%msg) <= $Pref::Merp::NameCharLimit && %n !$= ""){
		//Strips annoying font and color changes
		%msgs = %msg;
		%c.empireName = %msgs;
		if(%c.empireColor !$= ""){
			%c.fullEmpName = %c.empireColor @ %c.empireName;
			%c.clanPrefix = "\c6["@ %c.empireColor @ $Pref::Merp::EmpPrefixStyle @"\c6]";
		}
		else{
			%c.fullEmpName = "<color:FFFFFF>" @ %c.empireName;
			%c.clanPrefix = "\c6["@ "<color:FFFFFF>" @ $Pref::Merp::EmpPrefixStyle @"\c6]";
		}
		messageAll('MsgAdminForce',"\c3" @ %c.name @ "\c6 has created the glorious empire of" SPC %c.fullEmpName);
		//Makes a database of all empire names and colors
		$Merp::EmpNList = addItemToList($Merp::EmpNList,%c.empireName);
		$Merp::EmpCList = addItemToList($Merp::EmpCList,%c.empireColor);
		//Log it!
		if($Pref::Merp::LogsToggled){
			merpLog("Add-Ons/Server_BetterMERP/logs/empnames.txt",%msgs SPC "-" SPC %c.Name SPC "- BL_ID" SPC %c.bl_id);
		}
	}
	else{
		if(%n $= ""){messageClient(%c,'',"\c6You did not specify anything.");}
		if(%msg > $Pref::Merp::NameCharLimit){messageClient(%c,'',"\c6You must use an empire name under" SPC $Pref::Merp::NameCharLimit SPC "characters.");}
	}
}

package AyyLmao{
	//messageSent runs every time someone chats
	function serverCmdMessageSent(%c,%msg){
		//If first letter is >, type in empire chat
		if(getSubStr(%msg,0,1) $= ">"){
			//Make sure they have an empire
			if(%c.empireName !$= ""){
				messageAll('', "<font:palatino linotype:"@$Pref::Merp::EmpTextFontSize@">\c6[" @ %c.empireColor @ %c.empireName @ "\c6] :" SPC getSubStr(%msg,1,strLen(%msg)));
				if($Pref::Merp::LogsToggled){
					merpLog("Add-Ons/Server_BetterMERP/logs/empchat.txt","[" @%c.empireName@ "\c6]:" SPC getSubStr(%msg,1,strLen(%msg)));
				}
			}
			else{
				messageClient(%c,'',"\c6You do not have an empire.");
			}
		}
		//If it isnt, just do as normal
		else{
			parent::serverCmdMessageSent(%c,%msg);
		}
	}
	//autoAdminCheck runs every time a player connects
	function gameConnection::autoAdminCheck(%c){
		parent::autoAdminCheck(%c);
		if(%c.isSuperAdmin || %c.isAdmin){
			messageClient(%c,'msgAdminForce',"\c3Hello! You are using Better Mini Empires v1. Type /mHelpS for more info on admin-only commands, and /mHelp for normal ones.");
		}
		else{
			messageClient(%c,'',"\c6Welcome to Mini Empires! Type /mHelp for a list of all the commands you can use, like \c3/empirename \c6and \c3empirecolor.");
		}
		messageClient(%c,'',"\c6Use \c3>\c6 to type in empire chat.");
	}
};

activatePackage(AyyLmao);

//Original content time

function serverCmdrolldice(%c,%s)
{
	//Makes sure they didnt input nothing
	if(%s !$= ""){
		if(%s > $Pref::Merp::MaxRNum){
			messageClient(%c,'',"\c6That number is way too big! (must be under \c3"@$Pref::Merp::MaxRNum@"\c6)");
			return;
		}
		//Makes sure %s isnt a string or 0
		if(%s - 1 != -1 && %s != 0){
			%num = getRandom(1,%s);
			if(%num == 20 && %s == 20){
				messageAll('',"\c6" @ %c.name SPC "rolled a NAT 20! from a 20-sided die.");
			}
			else{
				messageAll('',"\c6" @ %c.name SPC "rolled a" SPC %num SPC "from a" SPC %s @ "-sided die.");
			}
		}
		else{
			messageClient(%c, '', "\c6That's either 0 or not a number. Either way it doesnt work so don't do that thanks.");
		}
	}
	else{
		//Default random number
		%num = getRandom(1,$Pref::Merp::DefaultRNum);
		if(%num == 20 && $Pref::Merp::DefaultRNum == 20){
				messageAll('',"\c6" @ %c.name SPC "rolled a NAT 20! from a 20-sided die.");
		}
		else{
			messageAll('',"\c6" @ %c.name SPC "rolled a" SPC %num SPC "from a" SPC $Pref::Merp::DefaultRNum @ "-sided die.");
		}
	}
}

//FUN STUFF WOOHOO
//But first yes and no

function serverCmdaccept(%this){
	if(%this.hasARequest){
		if(%this.typeReq !$= ""){
			%targ = findclientbyname(%this.Mrequestname);
			switch$(%this.typeReq){
				case "peace":
					messageAll('',"<font:palatino linotype:24>"@%this.fullEmpName@"\c6 has accepted peace with "@%targ.fullEmpName@"\c6.");
					for(%i=0;%i < %this.warCount;%i++){
						if(%this.atWar[%i] $= %targ.empireName){
							%this.atWar[%i] = "";
							break; 
						}
					}
					for(%i=0;%i < %targ.warCount;%i++){
						if(%targ.atWar[%i] $= %this.empireName){
							%targ.atWar[%i] = "";
							break;
						}
					}
					%targ.warCount = %targ.warCount - 1;
					%this.warCount = %this.warCount - 1;
					for(%i=0;%i <= $Merp::WarNum;%i++){
						%enum = $Merp::WarList[%i];
						if(%enum $= %this.fullempName SPC "\c6and" SPC %targ.fullempName || %enum $= %targ.fullempName SPC "\c6and" SPC %this.fullempName){
							$Merp::WarList[%i] = "";
							break;
						}	
					}
					$Merp::WarNum = $Merp::WarNum - 1;
					reqDelete(%this);
					if(isEventPending(%this.sched)){
						cancel(%this.sched);
					}
				case "ally":
					messageAll('',"<font:palatino linotype:24>" @ %this.fullEmpName@"\c6 has accepted "@%targ.fullEmpName@"\c6's alliance request.");
					%cwa = %this.allyCount;
					%twa = %targ.allyCount;
					if(%this.allyCount != 0){
						%this.allynum[%cwa] = %targ.empireName;
					}
					else{
						%this.allynum[0] = %targ.empireName;
					}
					if(%targ.allyCount != 0){
						%targ.allynum[%twa] = %this.empireName;
					}
					else{
						%targ.allynum[0] = %this.empireName;
					}
					$Merp::AllyNum = $Merp::AllyNum + 1;
					%this.allyCount = %this.allyCount + 1;
					%targ.allyCount = %targ.allyCount + 1;
					for(%i=0;%i<$Merp::AllyNum;%i++){
						%enum = $Merp::AllyList[%i];
						if(%enum $= ""){
							$Merp::AllyList[%i] = %this.fullEmpName SPC "\c6and" SPC %targ.fullEmpName;
							break;
						}	
					}
					reqDelete(%this);
					if(isEventPending(%this.sched)){
						cancel(%this.sched);
					}
				}
		}
		echo("[BetterMERP v1] - Something went wrong - /accept");
	}
	else{
		messageClient(%this,'',"\c6You don't have a peace or ally request to accept!");
	}
}

function serverCmddeny(%this){
	if(%this.hasARequest){
		if(%this.typeReq !$= ""){
			%targ = findclientbyname(%this.Mrequestname);
			switch$(%this.typeReq){
				case "peace":
					messageAll('',"<font:palatino linotype:23>"@ %this.fullEmpName @"\c6 has denied " @ %targ.fullEmpName @ "\c6 's peace request!!");
					if(isEventPending(%this.sched)){
						cancel(%this.sched);
					}
					reqDelete(%this);
				case "ally":
					messageAll('',"<font:palatino linotype:23>"@ %this.fullEmpName @"\c6 has denied " @ %targ.fullEmpName @ "\c6 's ally request.");
					if(isEventPending(%this.sched)){
						cancel(%this.sched);
					}
					reqDelete(%this);
			}
		}
		else{
			echo("[BetterMERP v1] - Something went wrong - /deny");
		}
	}
	else{
		messageClient(%this,'',"\c6You don't have a peace or ally request to deny!");
	}
}

//Now we get to war and peace, and allies
//And stuff

function serverCmddeclareWar(%c,%tn1,%tn2,%tn3){
	//Sets the name, same way as /empireName
	%name = stripMLControlChars(trim(%tn1 SPC %tn2 SPC %tn3));
	//Empire databases
	%emplist = $Merp::EmpNList;
	%empclist = $Merp::EmpCList;
	//If the %name isnt nothing
	if(%c.empireName !$= ""){
		if(%name !$= ""){
			//If its you, duh
			if(subString(%c.Name,%name)){
				messageClient(%c,'',"\c6That's (probably) you! Be a little more specific.");
				return;
			}
			%targ = findPlayerTargetMERP(%c.Name,%name);
			if(%targ == 0){
				return;
			}
			//If the emplist has the targets empire, DECLARE WAR
			if(hasItemOnList(%emplist,%targ.empireName)){
				if(mAtWarWith(%c,%targ)){
					messageClient(%c,'',"\c6You are already at war with\c3" SPC %targ.fullempname @ "\c6.");
					return;
				}
				if(mAllyWith(%c,%targ)){
					messageClient(%c,'',"\c6You can't declare war on your ally!");
					return;
				}
				%clename = %c.fullEmpName;
				%taename = %targ.fullEmpName;
				messageAll('msgAdminForce',"\c6<font:palatino linotype:24>"@%clename@"\c6 has declared war on "@%taename@"!!!");
				//We need this stuff so /makepeace and /makealliance work of course
				%cwa = %c.warCount;
				%twa = %targ.warCount;
				if(%c.warCount != 0){
					%c.atWar[%cwa] = %targ.empireName;
				}
				else{
					%c.atWar[0] = %targ.empireName;
				}
				if(%targ.warCount != 0){
					%targ.atWar[%twa] = %c.empireName;
				}
				else{
					%targ.atWar[0] = %c.empireName;
				}
				%targ.warCount = %targ.warCount + 1;
				%c.warCount = %c.warCount + 1;
				$Merp::WarNum = $Merp::WarNum + 1;
				for(%i=0;%i<$Merp::WarNum;%i++){
					%enum = $Merp::WarList[%i];
					if(%enum $= ""){
						$Merp::WarList[%i] = %c.fullEmpName SPC "\c6and" SPC %targ.fullEmpName;
						break;
					}
				}
			}
			else{
				//If it doesnt, well, they don't have an empire
				messageClient(%c,'',"\c6That player doesn't have an empire, warmonger!");
			}
		}
		else{
			//Self explanatory.
			messageClient(%c,'',"\c6You did not specify anything.");
		}
	}
	else{
		messageClient(%c,'',"\c6You do not have an empire!");
	}
}

function serverCmdmakePeace(%c,%tn1,%tn2,%tn3,%tn4){
	//Oh boy. Pretty much the same as /declareWar
	//but shorter..
	//but made 3 lines longer because of these comments....
	//four..
	%name = stripMLControlChars(trim(%tn1 SPC %tn2 SPC %tn3 SPC %tn4));
	%emplist = $Merp::EmpNList;
	%empclist = $Merp::EmpCList;
	if(%name !$= ""){
		if(subString(%c.name,%name)){
			messageClient(%c,'',"\c6That's (probably) you! Be a little more specific.");
			return;
		}
		%targ = findPlayerTargetMERP(%c.Name,%name);
		if(%targ == 0){
			return;
		}
		if(hasItemOnList(%emplist,%targ.empireName)){
			if(%targ.hasARequest){
				messageClient(%c,'',"\c3"@%targ.Name@"\c6 already has a request. Please try again.");
				return;
			}
			if(mAtWarWith(%c,%targ) == true){
				for(%i=0;%i<%targ.warCount;%i++){
					if(%targ.atWar[%i] $= %c.empireName){
						%targ.hasARequest = true;
						%targ.typeReq = "peace";
						%targ.Mrequestname = %c.Name;
						messageClient(%c,'',"\c6You have sent a peace request to \c3"@%targ.fullempName@"\c6.");
						messageClient(%targ,'',"\c3"@%c.fullEmpName@"\c6 has formally asked you for peace. Type \c3/accept\c6 to accept or \c3/deny \c6to decline.");
						messageAll('',"<font:palatino linotype:24>" @%c.fullEmpName@"\c6 has requested peace with "@%targ.fullEmpName@"\c6!!!");
						return;
					}
				}
			}
			else{
				messageClient(%c,'',"\c6You are not at war with \c3"@%targ.fullEmpName@"\c6!");
			}
		}
		else{
			messageClient(%c,'',"\c3"@%targ.Name@" doesn't even have an empire!");
		}
	}
	else{
		messageClient(%c,'',"\c6You did not specify anything.");
	}
}
//Alliance stuff: ooo
function servercmdmakealliance(%c,%t1,%t2,%t3,%t4){
	%name = stripMLControlChars(trim(%t1 SPC %t2 SPC %t3 SPC %t4));
	%emplist = $Merp::EmpNList;
	%empclist = $Merp::EmpCList;
	if(%c.empireName !$= ""){
		if(%name !$= ""){
			if(subString(%c.Name,%name)){
				messageClient(%c,'',"\c6That's (probably) you! Be a little more specific.");
				return;
			}
			%targ = findPlayerTargetMERP(%c.Name,%name);
			if(%targ == 0){
				return;
			}
			if(mAtWarWith(%c,%targ)){
				messageClient(%c,'',"\c6You can't ally with someone you're at war with!");
				return;
			}
			if(hasItemOnList(%emplist,%targ.empireName)){
				if(%targ.hasARequest){
					messageClient(%c,'',"\c3"@%targ.Name@"\c6 already has a request. Please try again.");
					return;
				}
				%targ.hasARequest = true;
				%targ.typeReq = "ally";
				%targ.Mrequestname = %c.Name;
				messageClient(%c,'',"\c6You have sent a alliance request to \c3"@%targ.fullEmpName@"\c6.");
				messageClient(%targ,'',"\c3"@%c.fullEmpName@"\c6 has formally asked you for an \c3alliance\c6. Type \c3/accept\c6 to accept or \c3/deny \c6to decline.");
				messageAll('',"<font:palatino linotype:24>"@%c.fullEmpName@"\c6 has requested an alliance with\c3 "@%targ.fullEmpName@"\c6.");
				schedule(1000*60*5,0,"reqDelete",%targ);
			}
			else{
				messageClient(%c,'',"\c3"@%targ.Name@"\c6 doesn't have an empire!");
			}
		}
		else{
			messageClient(%c,'',"\c6You didn't specify anything.");
		}
	}
	else{
		messageClient(%c,'',"\c6You do not have an empire!");
	}
}

function servercmdbreakalliance(%c,%t1,%t2,%t3,%t4){
	%name = stripMLControlChars(trim(%t1 SPC %t2 SPC %t3 SPC %t4));
	%emplist = $Merp::EmpNList;
	%empclist = $Merp::EmpCList;
	if(%name !$= ""){
		if(subString(%c.Name,%name)){
			messageClient(%c,'',"\c6That's (probably) you! Be a little more specific.");
			return;
		}
		%targ = findPlayerTargetMERP(%c.Name,%name);
		if(%targ == 0){
			return;
		}
		if(mAllyWith(%c,%targ)){
			if(%targ.allyCount != 0){
				for(%i=0;%i<%targ.allyCount;%i++){
					if(%targ.allynum[%i] $= %c.empireName){
						%targ.allynum[%i] = "";
						%targ.allyCount--;
					}
				}
				for(%i=0;%i<%c.allyCount;%i++){
					if(%c.allynum[%i] $= %targ.empireName){
						%c.allynum[%i] = "";
						%c.allyCount--;
					}
				}

				messageClient(%targ,'',"<font:palatino linotype:24>"@%c.fullEmpName @ " has broken their alliance with you!");
				messageAll('', "<font:palatino linotype:24>"@%c.fullEmpName @"\c6 has broken their alliance with " @ %targ.fullEmpName @ "\c6!!!");

				for(%i=0;%i<$Merp::AllyNum;%i++){
					%enum = $Merp::AllyList[%i];
					if(%enum $= %c.fullEmpName SPC "\c6and" SPC %targ.fullEmpName){
						$Merp::AllyList[%i] = "";
						break;
					}
				}
				$Merp::AllyNum = $Merp::AllyNum - 1;
				return;
			}
		}
		else{
			messageClient(%c,'',"\c6You are not allied with\c3 "@%targ.fullEmpName @ "\c6.");
		}
	}
	else{
		messageClient(%c,'',"\c6You didn't specify anything.");
	}
}


//Admin-only stuff oh my???
function serverCmdGodWhisper(%c,%t1,%m1,%m2,%m3,%m4,%m5,%m6,%m7,%m8,%m9,%m10,%m11,%m12,%m13,%m14){
	//Only if they're host, super admin, or admin
	if(%c.isSuperAdmin || %c.isAdmin){
		%name = trim(%t1 SPC %t2 SPC %t3 SPC %t4);
		%msg = trim(%m1 SPC %m2 SPC %m3 SPC %m4 SPC %m5 SPC %m6 SPC %m7 SPC %m8 SPC %m9 SPC %m10 SPC %m11 SPC %m12 SPC %m13 SPC %m14);
		if(%msg $= "" || %name $= ""){
			messageClient(%c,'',"\c6You did not specify anything.");
			return;
		}
		if(subString(%c.Name,%name)){
			messageClient(%c,'',"\c6That's (probably) you! Be a little more specific.");
			return;
		}
		%targa = findPlayerTargetMERP(%c.Name,%name);
		if(%targa == 0){
			return;
		}
		messageClient(%targa,'msgAdminForce',"\c6The gods whisper to you:" NL "\c3<font:palatino linotype:24>" @ %msg);
	}
	else{
		messageClient(%c,'',"\c6You are not an admin.");
	}
}
//Theres probably a better way to make messages like this, but i dont know it
function serverCmdmAnnounce(%c,%m1,%m2,%m3,%m4,%m5,%m6,%m7,%m8,%m9,%m10,%m11,%m12,%m13,%m14){
	//If admin or superadmin
	if(%c.isSuperAdmin || %c.isAdmin){
		%msg = trim(%m1 SPC %m2 SPC %m3 SPC %m4 SPC %m5 SPC %m6 SPC %m7 SPC %m8 SPC %m9 SPC %m10 SPC %m11 SPC %m12 SPC %m13 SPC %m14);
		if(%msg $= ""){
			messageClient(%c,'',"\c6You didn't type anything to announce.");
			return;
		}
		else{
			messageAll('msgAdminForce',"<font:palatino linotype:30>\c3Announcement:\c6"@ %msg);
		}
	}
	else{
		messageClient(%c,'',"\c6You are not an admin.");
	}
}

//And hey, another whisper too.
function serverCmdmwhisper(%c,%t1,%m3,%m4,%m5,%m6,%m7,%m8,%m9,%m10,%m11,%m12,%m13,%m14){
	%name = trim(%t1);
	%msg = trim(%m3 SPC %m4 SPC %m5 SPC %m6 SPC %m7 SPC %m8 SPC %m9 SPC %m10 SPC %m11 SPC %m12 SPC %m13 SPC %m14);
	if(%msg $= "" || %name $= ""){
		messageClient(%c,'',"\c6You did not specify anything.");
		return;
	}
	if(subString(%c.Name,%name)){
		messageClient(%c,'',"\c6That's (probably) you!");
		return;
	}
	%targa = findPlayerTargetMERP(%c.Name,%name);
	if(%targa == 0){
		return;
	}
	messageClient(%targa,'msgAdminForce',"\c3"@%c.Name@"\c5whispers to you: \c5" @ %msg);
	messageClient(%targa,'msgAdminForce',"\c3Type /mwhisper [name] [message] to reply.");
}

//Statuses
function servercmdwarStatus(%c){
	if($Merp::WarNum != 0){
		messageClient(%c,'',"\c3All Current Wars:");
		for(%i = 0;%i<$Merp::WarNum;%i++){
			messageClient(%c,'',$Merp::WarList[%i]);
		}
	}
	else{
		messageClient(%c,'',"\c6No official wars are happening right now.");
	}
}
function servercmdallystatus(%c){
	if($Merp::AllyNum != 0){
		messageClient(%c,'',"\c3All Current Alliances:");
		for(%i = 0;%i<$Merp::AllyNum;%i++){
			messageClient(%c,'',$Merp::AllyList[%i]);
		}
	}
	else{
		messageClient(%c,'',"\c6There are no offical alliances yet.");
	}
}

//From another addon i made

function serverCmdempirenamegen(%c){
	%num1 = getRandom(1, 12);
	%SevenGrandDad = getRandom(4, 20);
	switch(%num1){
		case 1: %rand1 = "The Republic of";
		case 2: %rand1 = "Socialist State of";
		case 3: %rand1 = "Soviet Republic of";
		case 4: %rand1 = "Kingdom of";
		case 5: %rand1 = "People's Republic of";
		case 6: %rand1 = "The" SPC %SevenGrandDad @"th Dynasty of";
		case 7: %rand1 = "United Socialist Union of";
		case 8: %rand1 = "Aristocracy of";
		case 9: %rand1 = "Oligarchy of";
		case 10: %rand1 = "Autocracy of";
		case 11: %rand1 = "Theocracy of";
		case 12: %rand1 = "Caliphate of";
	}
	%num2 = getRandom(1, 20);
	switch(%num2){
		case 1: %rand2 = "Azur";
		case 2: %rand2 = "Ausch";
		case 3: %rand2 = "Balt";
		case 4: %rand2 = "Arsto";
		case 5: %rand2 = "Blok";
		case 6: %rand2 = "Car";
		case 7: %rand2 = "Foxo";
		case 8: %rand2 = "Path";
		case 9: %rand2 = "Kebo";
		case 10: %rand2 = "Carg";
		case 11: %rand2 = "Rind";
		case 12: %rand2 = "Gro";
		case 13: %rand2 = "Marr";
		case 14: %rand2 = "Dilsto";
		case 15: %rand2 = "Koch";
		case 16: %rand2 = "Aristot";
		case 17: %rand2 = "Plato";
		case 18: %rand2 = "Vicino";
		case 19: %rand2 = "Zeno";
		case 20: %rand2 = "Musco";
	}
	%num3 = getRandom(1, 19);
	switch(%num3){
		case 1: %rand3 = "lat";
		case 2: %rand3 = "mar";
		case 3: %rand3 = "vi";
		case 4: %rand3 = "lal";
		case 5: %rand3 = "nil";
		case 6: %rand3 = "wil";
		case 7: %rand3 = "ask";
		case 8: %rand3 = "pop";
		case 9: %rand3 = "ke";
		case 10: %rand3 = "wo";
		case 11: %rand3 = "ta";
		case 12: %rand3 = "teh";
		case 13: %rand3 = "niv";
		case 14: %rand3 = "wr";
		case 15: %rand3 = "vol";
		case 16: %rand3 = "kot";
		case 17: %rand3 = "scot";
		case 18: %rand3 = "vil";
		case 19: %rand3 = "tz";
	}
	%num4 = getRandom(1, 9);
	switch(%num4){
		case 1: %rand4 = "itz";
		case 2: %rand4 = "ia";
		case 3: %rand4 = "ite";
		case 4: %rand4 = "ath";
		case 5: %rand4 = "ate";
		case 6: %rand4 = "ess";
		case 7: %rand4 = "shire";
		case 8: %rand4 = "ton";
		case 9: %rand4 = "ka";
	}
	if(%rand2 @ %rand3 @ %rand4 $= "Arstotzka"){
		messageClient(%c,'',"\c6Glory to \c3" SPC %rand2 @ %rand3 @ %rand4);
		messageClient(%c,'',"\c6That message had a 1/3420 chance to appear. Yes I did the math. Lucky you.");
		return;
	}
	messageClient(%c, '', "\c6Your random empire name is: \c3" SPC %rand1 SPC %rand2 @ %rand3 @ %rand4);
}